"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const map_1 = require("../util/map");
const exception_1 = require("./exception");
class Enum {
    constructor() {
        let enums = Enum.enums, constructor = Object.getPrototypeOf(this).constructor;
        if (!enums.containsKey(constructor)) {
            enums.put(constructor, []);
        }
        enums.get(constructor).push(this);
    }
    static of(name) {
        if (!this.hasOwnProperty(name)) {
            throw new exception_1.IllegalArgumentException(`Enum '${name}' is not found from ${this.name}`);
        }
        return this[name];
    }
    static values() {
        return Enum.enums.getOrDefault(this, []);
    }
}
Enum.enums = new map_1.HashMap();
exports.Enum = Enum;
//# sourceMappingURL=enum.js.map